---
title: llarp::I_RCGossiper

---

# llarp::I_RCGossiper





Inherited by [llarp::RCGossiper](Classes/structllarp_1_1RCGossiper.md)

## Public Types

|                | Name           |
| -------------- | -------------- |
| using std::chrono::milliseconds | **[Time_t](Classes/structllarp_1_1I__RCGossiper.md#using-time-t)**  |

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual | **[~I_RCGossiper](Classes/structllarp_1_1I__RCGossiper.md#function-~i-rcgossiper)**() =default |
| virtual bool | **[GossipRC](Classes/structllarp_1_1I__RCGossiper.md#function-gossiprc)**(const [RouterContact](Classes/structllarp_1_1RouterContact.md) & rc) =0<br>try goissping RC return false if we hit a cooldown for this rc return true if we gossiped this rc to at least 1 peer  |
| virtual void | **[Decay](Classes/structllarp_1_1I__RCGossiper.md#function-decay)**(Time_t now) =0 |
| virtual bool | **[ShouldGossipOurRC](Classes/structllarp_1_1I__RCGossiper.md#function-shouldgossipourrc)**(Time_t now) const =0<br>return true if we should gossip our RC now  |
| virtual bool | **[IsOurRC](Classes/structllarp_1_1I__RCGossiper.md#function-isourrc)**(const [RouterContact](Classes/structllarp_1_1RouterContact.md) & rc) const =0<br>return true if that rc is owned by us  |

## Public Types Documentation

### using Time_t

```cpp
using llarp::I_RCGossiper::Time_t =  std::chrono::milliseconds;
```


## Public Functions Documentation

### function ~I_RCGossiper

```cpp
virtual ~I_RCGossiper() =default
```


### function GossipRC

```cpp
virtual bool GossipRC(
    const RouterContact & rc
) =0
```

try goissping RC return false if we hit a cooldown for this rc return true if we gossiped this rc to at least 1 peer 

**Reimplemented by**: [llarp::RCGossiper::GossipRC](Classes/structllarp_1_1RCGossiper.md#function-gossiprc)


### function Decay

```cpp
virtual void Decay(
    Time_t now
) =0
```


**Reimplemented by**: [llarp::RCGossiper::Decay](Classes/structllarp_1_1RCGossiper.md#function-decay)


### function ShouldGossipOurRC

```cpp
virtual bool ShouldGossipOurRC(
    Time_t now
) const =0
```

return true if we should gossip our RC now 

**Reimplemented by**: [llarp::RCGossiper::ShouldGossipOurRC](Classes/structllarp_1_1RCGossiper.md#function-shouldgossipourrc)


### function IsOurRC

```cpp
virtual bool IsOurRC(
    const RouterContact & rc
) const =0
```

return true if that rc is owned by us 

**Reimplemented by**: [llarp::RCGossiper::IsOurRC](Classes/structllarp_1_1RCGossiper.md#function-isourrc)


-------------------------------

Updated on 2022-05-24 at 16:57:31 +0000