---
title: llarp::OStreamLogStream

---

# llarp::OStreamLogStream





Inherits from [llarp::ILogStream](Classes/structllarp_1_1ILogStream.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[OStreamLogStream](Classes/structllarp_1_1OStreamLogStream.md#function-ostreamlogstream)**(bool withColours, std::ostream & out) |
| | **[~OStreamLogStream](Classes/structllarp_1_1OStreamLogStream.md#function-~ostreamlogstream)**() override =default |
| virtual void | **[PreLog](Classes/structllarp_1_1OStreamLogStream.md#function-prelog)**(std::stringstream & s, LogLevel lvl, std::string_view filename, int lineno, const std::string & nodename) const override |
| virtual void | **[Print](Classes/structllarp_1_1OStreamLogStream.md#function-print)**(LogLevel lvl, std::string_view tag, const std::string & msg) override |
| virtual void | **[PostLog](Classes/structllarp_1_1OStreamLogStream.md#function-postlog)**(std::stringstream & ss) const override |
| virtual void | **[ImmediateFlush](Classes/structllarp_1_1OStreamLogStream.md#function-immediateflush)**() override<br>A blocking call to flush to disk. Should only be called in rare circumstances.  |
| virtual void | **[Tick](Classes/structllarp_1_1OStreamLogStream.md#function-tick)**(llarp_time_t now) override<br>called every end of event loop tick  |

## Additional inherited members

**Public Functions inherited from [llarp::ILogStream](Classes/structllarp_1_1ILogStream.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~ILogStream](Classes/structllarp_1_1ILogStream.md#function-~ilogstream)**() =default |
| virtual void | **[AppendLog](Classes/structllarp_1_1ILogStream.md#function-appendlog)**(LogLevel lvl, std::string_view filename, int lineno, const std::string & nodename, const std::string msg) |


## Public Functions Documentation

### function OStreamLogStream

```cpp
OStreamLogStream(
    bool withColours,
    std::ostream & out
)
```


### function ~OStreamLogStream

```cpp
~OStreamLogStream() override =default
```


### function PreLog

```cpp
virtual void PreLog(
    std::stringstream & s,
    LogLevel lvl,
    std::string_view filename,
    int lineno,
    const std::string & nodename
) const override
```


**Reimplements**: [llarp::ILogStream::PreLog](Classes/structllarp_1_1ILogStream.md#function-prelog)


### function Print

```cpp
virtual void Print(
    LogLevel lvl,
    std::string_view tag,
    const std::string & msg
) override
```


**Reimplements**: [llarp::ILogStream::Print](Classes/structllarp_1_1ILogStream.md#function-print)


### function PostLog

```cpp
virtual void PostLog(
    std::stringstream & ss
) const override
```


**Reimplements**: [llarp::ILogStream::PostLog](Classes/structllarp_1_1ILogStream.md#function-postlog)


### function ImmediateFlush

```cpp
virtual void ImmediateFlush() override
```

A blocking call to flush to disk. Should only be called in rare circumstances. 

**Reimplements**: [llarp::ILogStream::ImmediateFlush](Classes/structllarp_1_1ILogStream.md#function-immediateflush)


### function Tick

```cpp
inline virtual void Tick(
    llarp_time_t now
) override
```

called every end of event loop tick 

**Reimplements**: [llarp::ILogStream::Tick](Classes/structllarp_1_1ILogStream.md#function-tick)


-------------------------------

Updated on 2022-05-24 at 16:57:31 +0000