---
title: llarp/dns/name.hpp

---

# llarp/dns/name.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::dns](Namespaces/namespacellarp_1_1dns.md)**  |




## Source code

```cpp
#pragma once

#include <llarp/net/net_int.hpp>
#include <llarp/util/buffer.hpp>

#include <string>

namespace llarp
{
  namespace dns
  {
    using Name_t = std::string;

    bool
    DecodeName(llarp_buffer_t* buf, Name_t& name, bool trimTrailingDot = false);

    bool
    EncodeName(llarp_buffer_t* buf, Name_t name);

    bool
    DecodePTR(Name_t name, huint128_t& ip);

    bool
    NameIsReserved(Name_t name);

  }  // namespace dns
}  // namespace llarp
```


-------------------------------

Updated on 2022-05-24 at 16:57:32 +0000
