---
title: llarp/router/i_gossiper.hpp

---

# llarp/router/i_gossiper.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::I_RCGossiper](Classes/structllarp_1_1I__RCGossiper.md)**  |




## Source code

```cpp
#pragma once
#include <llarp/router_contact.hpp>

namespace llarp
{
  constexpr size_t MaxGossipPeers = 20;

  struct I_RCGossiper
  {
    virtual ~I_RCGossiper() = default;
    virtual bool
    GossipRC(const RouterContact& rc) = 0;

    using Time_t = std::chrono::milliseconds;

    virtual void
    Decay(Time_t now) = 0;

    virtual bool
    ShouldGossipOurRC(Time_t now) const = 0;

    virtual bool
    IsOurRC(const RouterContact& rc) const = 0;
  };
}  // namespace llarp
```


-------------------------------

Updated on 2022-05-24 at 16:57:33 +0000
